#ifndef CGraphH
#define CGraphH

#include <vector>
#include <CVector.h>

extern "C"  void dsaupd_(int *ido, char *bmat, int *n, char *which,
			int *nev, double *tol, double *resid, int *ncv,
			double *v, int *ldv, int *iparam, int *ipntr,
			double *workd, double *workl, int *lworkl,
			int *info);

extern "C"  void dseupd_(int *rvec, char *All, int *select, double *d,
			double *v, int *ldv, double *sigma, 
			char *bmat, int *n, char *which, int *nev,
			double *tol, double *resid, int *ncv, double *v2,
			int *ldv2, int *iparam, int *ipntr, double *workd,
			double *workl, int *lworkl, int *ierr);

class CEdge {
public:
  CEdge() {}
  CEdge(int aNode, float aWeight) : mNode(aNode),mWeight(aWeight) {}
  int mNode;
  float mWeight;
  void readFromFile(std::ifstream& aIn) { aIn.read((char*)&mNode,sizeof(mNode)); aIn.read((char*)&mWeight,sizeof(mWeight)); }
  void writeToFile(std::ofstream& aOut) { aOut.write((char*)&mNode,sizeof(mNode)); aOut.write((char*)&mWeight,sizeof(mWeight)); }
};

typedef std::vector<std::vector<CEdge> > CGraph;

void lanczos(CGraph& aGraph, CVector<float>& X);
void lanczos(CGraph& aGraph, CVector<bool>& aValidNodes, CVector<float>& X);
void ncut(CGraph& aGraph, CVector<bool>& aValidNodes, CMatrix<float>& eigVecs, CVector<float>& eigVals, int aRegionNo);

#endif


