#include <CTensor.h>

int main(int argc, char** args) {
  if (argc <= 9) {
    std::cout << "Usage: combine name1 name2 name3 firstno1 lastno1 firstno2 lastno2 zeros1 zeros2 [h/v]" << std::endl;
    return -1;
  }
  int a1 = atoi(args[4]);
  int a2 = atoi(args[5]);
  int b1 = atoi(args[6]);
  int b2 = atoi(args[7]);
  CTensor<float> aIn1;
  CTensor<float> aIn2;
  CTensor<float> aOut;
  int aCount = a2-a1+1;
  if (aCount != b2-b1+1) {
    std::cout << "Number of images does not match" << std::endl;
    return -1;
  }
  char buffer[200];
  for (int i = 0; i < aCount; i++) {
    if (atoi(args[8]) == 2) sprintf(buffer,"%s%02d.ppm",args[1],a1+i);
    else if (atoi(args[8]) == 3) sprintf(buffer,"%s%03d.ppm",args[1],a1+i);
    else if (atoi(args[8]) == 4) sprintf(buffer,"%s%04d.ppm",args[1],a1+i);
    aIn1.readFromPPM(buffer);
    if (atoi(args[9]) == 2) sprintf(buffer,"%s%02d.ppm",args[2],b1+i);
    else if (atoi(args[9]) == 3) sprintf(buffer,"%s%03d.ppm",args[2],b1+i);
    else if (atoi(args[9]) == 4) sprintf(buffer,"%s%04d.ppm",args[2],b1+i);
    aIn2.readFromPPM(buffer);
    int aXSize = aIn1.xSize();
    int aYSize = aIn1.ySize();
    #if 0
    aOut.setSize(2*aXSize,aYSize,3);
    aOut.paste(aIn1,0,0,0);
    aOut.paste(aIn2,aXSize,0,0);
    #else
    aOut.setSize(aXSize,2*aYSize,3);
    aOut.paste(aIn1,0,0,0);
    aOut.paste(aIn2,0,aYSize,0);
    #endif
    sprintf(buffer,"%s%03d.ppm",args[3],a1+i);
    aOut.writeToPPM(buffer);
  }
  return 0;
}

